]> asedeno.scripts.mit.edu Git - git.git/blob - git-am.sh
am: allow individual e-mail files as input
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
4
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [<mbox>|<Maildir>...]
9 git am [options] (--resolved | --skip | --abort)
10 --
11 i,interactive   run interactively
12 b,binary*       (historical option -- no-op)
13 3,3way          allow fall back on 3way merging if needed
14 q,quiet         be quiet
15 s,signoff       add a Signed-off-by line to the commit message
16 u,utf8          recode into utf8 (default)
17 k,keep          pass -k flag to git-mailinfo
18 whitespace=     pass it through git-apply
19 directory=      pass it through git-apply
20 C=              pass it through git-apply
21 p=              pass it through git-apply
22 patch-format=   format the patch(es) are in
23 reject          pass it through git-apply
24 resolvemsg=     override error message when patch failure occurs
25 r,resolved      to be used after a patch failure
26 skip            skip the current patch
27 abort           restore the original branch and abort the patching operation.
28 committer-date-is-author-date    lie about committer date
29 ignore-date     use current timestamp for author date
30 rebasing*       (internal use for git-rebase)"
31
32 . git-sh-setup
33 prefix=$(git rev-parse --show-prefix)
34 set_reflog_action am
35 require_work_tree
36 cd_to_toplevel
37
38 git var GIT_COMMITTER_IDENT >/dev/null ||
39         die "You need to set your committer info first"
40
41 if git rev-parse --verify -q HEAD >/dev/null
42 then
43         HAS_HEAD=yes
44 else
45         HAS_HEAD=
46 fi
47
48 sq () {
49         git rev-parse --sq-quote "$@"
50 }
51
52 stop_here () {
53     echo "$1" >"$dotest/next"
54     exit 1
55 }
56
57 stop_here_user_resolve () {
58     if [ -n "$resolvemsg" ]; then
59             printf '%s\n' "$resolvemsg"
60             stop_here $1
61     fi
62     cmdline="git am"
63     if test '' != "$interactive"
64     then
65         cmdline="$cmdline -i"
66     fi
67     if test '' != "$threeway"
68     then
69         cmdline="$cmdline -3"
70     fi
71     echo "When you have resolved this problem run \"$cmdline --resolved\"."
72     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
73     echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
74
75     stop_here $1
76 }
77
78 go_next () {
79         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
80                 "$dotest/patch" "$dotest/info"
81         echo "$next" >"$dotest/next"
82         this=$next
83 }
84
85 cannot_fallback () {
86         echo "$1"
87         echo "Cannot fall back to three-way merge."
88         exit 1
89 }
90
91 fall_back_3way () {
92     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
93
94     rm -fr "$dotest"/patch-merge-*
95     mkdir "$dotest/patch-merge-tmp-dir"
96
97     # First see if the patch records the index info that we can use.
98     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
99         "$dotest/patch" &&
100     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
101     git write-tree >"$dotest/patch-merge-base+" ||
102     cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
103
104     say Using index info to reconstruct a base tree...
105     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
106         git apply --cached <"$dotest/patch"
107     then
108         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
109         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
110     else
111         cannot_fallback "Did you hand edit your patch?
112 It does not apply to blobs recorded in its index."
113     fi
114
115     test -f "$dotest/patch-merge-index" &&
116     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
117     orig_tree=$(cat "$dotest/patch-merge-base") &&
118     rm -fr "$dotest"/patch-merge-* || exit 1
119
120     say Falling back to patching base and 3-way merge...
121
122     # This is not so wrong.  Depending on which base we picked,
123     # orig_tree may be wildly different from ours, but his_tree
124     # has the same set of wildly different changes in parts the
125     # patch did not touch, so recursive ends up canceling them,
126     # saying that we reverted all those changes.
127
128     eval GITHEAD_$his_tree='"$FIRSTLINE"'
129     export GITHEAD_$his_tree
130     if test -n "$GIT_QUIET"
131     then
132             export GIT_MERGE_VERBOSITY=0
133     fi
134     git-merge-recursive $orig_tree -- HEAD $his_tree || {
135             git rerere
136             echo Failed to merge in the changes.
137             exit 1
138     }
139     unset GITHEAD_$his_tree
140 }
141
142 clean_abort () {
143         test $# = 0 || echo >&2 "$@"
144         rm -fr "$dotest"
145         exit 1
146 }
147
148 patch_format=
149
150 check_patch_format () {
151         # early return if patch_format was set from the command line
152         if test -n "$patch_format"
153         then
154                 return 0
155         fi
156
157         # we default to mbox format if input is from stdin and for
158         # directories
159         if test $# = 0 || test "x$1" = "x-" || test -d "$1"
160         then
161                 patch_format=mbox
162                 return 0
163         fi
164
165         # otherwise, check the first few lines of the first patch to try
166         # to detect its format
167         {
168                 read l1
169                 read l2
170                 read l3
171                 case "$l1" in
172                 "From "* | "From: "*)
173                         patch_format=mbox
174                         ;;
175                 '# This series applies on GIT commit'*)
176                         patch_format=stgit-series
177                         ;;
178                 "# HG changeset patch")
179                         patch_format=hg
180                         ;;
181                 *)
182                         # if the second line is empty and the third is
183                         # a From, Author or Date entry, this is very
184                         # likely an StGIT patch
185                         case "$l2,$l3" in
186                         ,"From: "* | ,"Author: "* | ,"Date: "*)
187                                 patch_format=stgit
188                                 ;;
189                         *)
190                                 ;;
191                         esac
192                         ;;
193                 esac
194                 if test -z "$patch_format" &&
195                         test -n "$l1" &&
196                         test -n "$l2" &&
197                         test -n "$l3"
198                 then
199                         # This begins with three non-empty lines.  Is this a
200                         # piece of e-mail a-la RFC2822?  Grab all the headers,
201                         # discarding the indented remainder of folded lines,
202                         # and see if it looks like that they all begin with the
203                         # header field names...
204                         sed -n -e '/^$/q' -e '/^[       ]/d' -e p "$1" |
205                         egrep -v '^[A-Za-z]+(-[A-Za-z]+)*:' >/dev/null ||
206                         patch_format=mbox
207                 fi
208         } < "$1" || clean_abort
209 }
210
211 split_patches () {
212         case "$patch_format" in
213         mbox)
214                 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||
215                 clean_abort
216                 ;;
217         stgit-series)
218                 if test $# -ne 1
219                 then
220                         clean_abort "Only one StGIT patch series can be applied at once"
221                 fi
222                 series_dir=`dirname "$1"`
223                 series_file="$1"
224                 shift
225                 {
226                         set x
227                         while read filename
228                         do
229                                 set "$@" "$series_dir/$filename"
230                         done
231                         # remove the safety x
232                         shift
233                         # remove the arg coming from the first-line comment
234                         shift
235                 } < "$series_file" || clean_abort
236                 # set the patch format appropriately
237                 patch_format=stgit
238                 # now handle the actual StGIT patches
239                 split_patches "$@"
240                 ;;
241         stgit)
242                 this=0
243                 for stgit in "$@"
244                 do
245                         this=`expr "$this" + 1`
246                         msgnum=`printf "%0${prec}d" $this`
247                         # Perl version of StGIT parse_patch. The first nonemptyline
248                         # not starting with Author, From or Date is the
249                         # subject, and the body starts with the next nonempty
250                         # line not starting with Author, From or Date
251                         perl -ne 'BEGIN { $subject = 0 }
252                                 if ($subject > 1) { print ; }
253                                 elsif (/^\s+$/) { next ; }
254                                 elsif (/^Author:/) { print s/Author/From/ ; }
255                                 elsif (/^(From|Date)/) { print ; }
256                                 elsif ($subject) {
257                                         $subject = 2 ;
258                                         print "\n" ;
259                                         print ;
260                                 } else {
261                                         print "Subject: ", $_ ;
262                                         $subject = 1;
263                                 }
264                         ' < "$stgit" > "$dotest/$msgnum" || clean_abort
265                 done
266                 echo "$this" > "$dotest/last"
267                 this=
268                 msgnum=
269                 ;;
270         *)
271                 clean_abort "Patch format $patch_format is not supported."
272                 ;;
273         esac
274 }
275
276 prec=4
277 dotest="$GIT_DIR/rebase-apply"
278 sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
279 resolvemsg= resume=
280 git_apply_opt=
281 committer_date_is_author_date=
282 ignore_date=
283
284 while test $# != 0
285 do
286         case "$1" in
287         -i|--interactive)
288                 interactive=t ;;
289         -b|--binary)
290                 : ;;
291         -3|--3way)
292                 threeway=t ;;
293         -s|--signoff)
294                 sign=t ;;
295         -u|--utf8)
296                 utf8=t ;; # this is now default
297         --no-utf8)
298                 utf8= ;;
299         -k|--keep)
300                 keep=t ;;
301         -r|--resolved)
302                 resolved=t ;;
303         --skip)
304                 skip=t ;;
305         --abort)
306                 abort=t ;;
307         --rebasing)
308                 rebasing=t threeway=t keep=t ;;
309         -d|--dotest)
310                 die "-d option is no longer supported.  Do not use."
311                 ;;
312         --resolvemsg)
313                 shift; resolvemsg=$1 ;;
314         --whitespace|--directory)
315                 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
316         -C|-p)
317                 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
318         --patch-format)
319                 shift ; patch_format="$1" ;;
320         --reject)
321                 git_apply_opt="$git_apply_opt $1" ;;
322         --committer-date-is-author-date)
323                 committer_date_is_author_date=t ;;
324         --ignore-date)
325                 ignore_date=t ;;
326         -q|--quiet)
327                 GIT_QUIET=t ;;
328         --)
329                 shift; break ;;
330         *)
331                 usage ;;
332         esac
333         shift
334 done
335
336 # If the dotest directory exists, but we have finished applying all the
337 # patches in them, clear it out.
338 if test -d "$dotest" &&
339    last=$(cat "$dotest/last") &&
340    next=$(cat "$dotest/next") &&
341    test $# != 0 &&
342    test "$next" -gt "$last"
343 then
344    rm -fr "$dotest"
345 fi
346
347 if test -d "$dotest"
348 then
349         case "$#,$skip$resolved$abort" in
350         0,*t*)
351                 # Explicit resume command and we do not have file, so
352                 # we are happy.
353                 : ;;
354         0,)
355                 # No file input but without resume parameters; catch
356                 # user error to feed us a patch from standard input
357                 # when there is already $dotest.  This is somewhat
358                 # unreliable -- stdin could be /dev/null for example
359                 # and the caller did not intend to feed us a patch but
360                 # wanted to continue unattended.
361                 test -t 0
362                 ;;
363         *)
364                 false
365                 ;;
366         esac ||
367         die "previous rebase directory $dotest still exists but mbox given."
368         resume=yes
369
370         case "$skip,$abort" in
371         t,t)
372                 die "Please make up your mind. --skip or --abort?"
373                 ;;
374         t,)
375                 git rerere clear
376                 git read-tree --reset -u HEAD HEAD
377                 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
378                 git reset HEAD
379                 git update-ref ORIG_HEAD $orig_head
380                 ;;
381         ,t)
382                 if test -f "$dotest/rebasing"
383                 then
384                         exec git rebase --abort
385                 fi
386                 git rerere clear
387                 test -f "$dotest/dirtyindex" || {
388                         git read-tree --reset -u HEAD ORIG_HEAD
389                         git reset ORIG_HEAD
390                 }
391                 rm -fr "$dotest"
392                 exit ;;
393         esac
394         rm -f "$dotest/dirtyindex"
395 else
396         # Make sure we are not given --skip, --resolved, nor --abort
397         test "$skip$resolved$abort" = "" ||
398                 die "Resolve operation not in progress, we are not resuming."
399
400         # Start afresh.
401         mkdir -p "$dotest" || exit
402
403         if test -n "$prefix" && test $# != 0
404         then
405                 first=t
406                 for arg
407                 do
408                         test -n "$first" && {
409                                 set x
410                                 first=
411                         }
412                         case "$arg" in
413                         /*)
414                                 set "$@" "$arg" ;;
415                         *)
416                                 set "$@" "$prefix$arg" ;;
417                         esac
418                 done
419                 shift
420         fi
421
422         check_patch_format "$@"
423
424         split_patches "$@"
425
426         # -s, -u, -k, --whitespace, -3, -C, -q and -p flags are kept
427         # for the resuming session after a patch failure.
428         # -i can and must be given when resuming.
429         echo " $git_apply_opt" >"$dotest/apply-opt"
430         echo "$threeway" >"$dotest/threeway"
431         echo "$sign" >"$dotest/sign"
432         echo "$utf8" >"$dotest/utf8"
433         echo "$keep" >"$dotest/keep"
434         echo "$GIT_QUIET" >"$dotest/quiet"
435         echo 1 >"$dotest/next"
436         if test -n "$rebasing"
437         then
438                 : >"$dotest/rebasing"
439         else
440                 : >"$dotest/applying"
441                 if test -n "$HAS_HEAD"
442                 then
443                         git update-ref ORIG_HEAD HEAD
444                 else
445                         git update-ref -d ORIG_HEAD >/dev/null 2>&1
446                 fi
447         fi
448 fi
449
450 case "$resolved" in
451 '')
452         case "$HAS_HEAD" in
453         '')
454                 files=$(git ls-files) ;;
455         ?*)
456                 files=$(git diff-index --cached --name-only HEAD --) ;;
457         esac || exit
458         if test "$files"
459         then
460                 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
461                 die "Dirty index: cannot apply patches (dirty: $files)"
462         fi
463 esac
464
465 if test "$(cat "$dotest/utf8")" = t
466 then
467         utf8=-u
468 else
469         utf8=-n
470 fi
471 if test "$(cat "$dotest/keep")" = t
472 then
473         keep=-k
474 fi
475 if test "$(cat "$dotest/quiet")" = t
476 then
477         GIT_QUIET=t
478 fi
479 if test "$(cat "$dotest/threeway")" = t
480 then
481         threeway=t
482 fi
483 git_apply_opt=$(cat "$dotest/apply-opt")
484 if test "$(cat "$dotest/sign")" = t
485 then
486         SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
487                         s/>.*/>/
488                         s/^/Signed-off-by: /'
489                 `
490 else
491         SIGNOFF=
492 fi
493
494 last=`cat "$dotest/last"`
495 this=`cat "$dotest/next"`
496 if test "$skip" = t
497 then
498         this=`expr "$this" + 1`
499         resume=
500 fi
501
502 if test "$this" -gt "$last"
503 then
504         say Nothing to do.
505         rm -fr "$dotest"
506         exit
507 fi
508
509 while test "$this" -le "$last"
510 do
511         msgnum=`printf "%0${prec}d" $this`
512         next=`expr "$this" + 1`
513         test -f "$dotest/$msgnum" || {
514                 resume=
515                 go_next
516                 continue
517         }
518
519         # If we are not resuming, parse and extract the patch information
520         # into separate files:
521         #  - info records the authorship and title
522         #  - msg is the rest of commit log message
523         #  - patch is the patch body.
524         #
525         # When we are resuming, these files are either already prepared
526         # by the user, or the user can tell us to do so by --resolved flag.
527         case "$resume" in
528         '')
529                 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
530                         <"$dotest/$msgnum" >"$dotest/info" ||
531                         stop_here $this
532
533                 # skip pine's internal folder data
534                 grep '^Author: Mail System Internal Data$' \
535                         <"$dotest"/info >/dev/null &&
536                         go_next && continue
537
538                 test -s "$dotest/patch" || {
539                         echo "Patch is empty.  Was it split wrong?"
540                         stop_here $this
541                 }
542                 if test -f "$dotest/rebasing" &&
543                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
544                                 -e q "$dotest/$msgnum") &&
545                         test "$(git cat-file -t "$commit")" = commit
546                 then
547                         git cat-file commit "$commit" |
548                         sed -e '1,/^$/d' >"$dotest/msg-clean"
549                 else
550                         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
551                         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
552
553                         (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
554                                 git stripspace > "$dotest/msg-clean"
555                 fi
556                 ;;
557         esac
558
559         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
560         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
561         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
562
563         if test -z "$GIT_AUTHOR_EMAIL"
564         then
565                 echo "Patch does not have a valid e-mail address."
566                 stop_here $this
567         fi
568
569         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
570
571         case "$resume" in
572         '')
573             if test '' != "$SIGNOFF"
574             then
575                 LAST_SIGNED_OFF_BY=`
576                     sed -ne '/^Signed-off-by: /p' \
577                     "$dotest/msg-clean" |
578                     sed -ne '$p'
579                 `
580                 ADD_SIGNOFF=`
581                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
582                     test '' = "$LAST_SIGNED_OFF_BY" && echo
583                     echo "$SIGNOFF"
584                 }`
585             else
586                 ADD_SIGNOFF=
587             fi
588             {
589                 if test -s "$dotest/msg-clean"
590                 then
591                         cat "$dotest/msg-clean"
592                 fi
593                 if test '' != "$ADD_SIGNOFF"
594                 then
595                         echo "$ADD_SIGNOFF"
596                 fi
597             } >"$dotest/final-commit"
598             ;;
599         *)
600                 case "$resolved$interactive" in
601                 tt)
602                         # This is used only for interactive view option.
603                         git diff-index -p --cached HEAD -- >"$dotest/patch"
604                         ;;
605                 esac
606         esac
607
608         resume=
609         if test "$interactive" = t
610         then
611             test -t 0 ||
612             die "cannot be interactive without stdin connected to a terminal."
613             action=again
614             while test "$action" = again
615             do
616                 echo "Commit Body is:"
617                 echo "--------------------------"
618                 cat "$dotest/final-commit"
619                 echo "--------------------------"
620                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
621                 read reply
622                 case "$reply" in
623                 [yY]*) action=yes ;;
624                 [aA]*) action=yes interactive= ;;
625                 [nN]*) action=skip ;;
626                 [eE]*) git_editor "$dotest/final-commit"
627                        action=again ;;
628                 [vV]*) action=again
629                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
630                 *)     action=again ;;
631                 esac
632             done
633         else
634             action=yes
635         fi
636         FIRSTLINE=$(sed 1q "$dotest/final-commit")
637
638         if test $action = skip
639         then
640                 go_next
641                 continue
642         fi
643
644         if test -x "$GIT_DIR"/hooks/applypatch-msg
645         then
646                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
647                 stop_here $this
648         fi
649
650         say "Applying: $FIRSTLINE"
651
652         case "$resolved" in
653         '')
654                 # When we are allowed to fall back to 3-way later, don't give
655                 # false errors during the initial attempt.
656                 squelch=
657                 if test "$threeway" = t
658                 then
659                         squelch='>/dev/null 2>&1 '
660                 fi
661                 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
662                 apply_status=$?
663                 ;;
664         t)
665                 # Resolved means the user did all the hard work, and
666                 # we do not have to do any patch application.  Just
667                 # trust what the user has in the index file and the
668                 # working tree.
669                 resolved=
670                 git diff-index --quiet --cached HEAD -- && {
671                         echo "No changes - did you forget to use 'git add'?"
672                         stop_here_user_resolve $this
673                 }
674                 unmerged=$(git ls-files -u)
675                 if test -n "$unmerged"
676                 then
677                         echo "You still have unmerged paths in your index"
678                         echo "did you forget to use 'git add'?"
679                         stop_here_user_resolve $this
680                 fi
681                 apply_status=0
682                 git rerere
683                 ;;
684         esac
685
686         if test $apply_status = 1 && test "$threeway" = t
687         then
688                 if (fall_back_3way)
689                 then
690                     # Applying the patch to an earlier tree and merging the
691                     # result may have produced the same tree as ours.
692                     git diff-index --quiet --cached HEAD -- && {
693                         say No changes -- Patch already applied.
694                         go_next
695                         continue
696                     }
697                     # clear apply_status -- we have successfully merged.
698                     apply_status=0
699                 fi
700         fi
701         if test $apply_status != 0
702         then
703                 printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
704                 stop_here_user_resolve $this
705         fi
706
707         if test -x "$GIT_DIR"/hooks/pre-applypatch
708         then
709                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
710         fi
711
712         tree=$(git write-tree) &&
713         commit=$(
714                 if test -n "$ignore_date"
715                 then
716                         GIT_AUTHOR_DATE=
717                 fi
718                 parent=$(git rev-parse --verify -q HEAD) ||
719                 say >&2 "applying to an empty history"
720
721                 if test -n "$committer_date_is_author_date"
722                 then
723                         GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
724                         export GIT_COMMITTER_DATE
725                 fi &&
726                 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
727         ) &&
728         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
729         stop_here $this
730
731         if test -x "$GIT_DIR"/hooks/post-applypatch
732         then
733                 "$GIT_DIR"/hooks/post-applypatch
734         fi
735
736         go_next
737 done
738
739 git gc --auto
740
741 rm -fr "$dotest"